﻿
'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict On
Option Explicit On

Imports __InvoiceDetail = LightSwitchApplication.InvoiceDetail

Namespace LightSwitchApplication

    #Region "Entities"
    
    ''' <summary>
    ''' No Modeled Description Available
    ''' </summary>
    <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
    Public NotInheritable Partial Class InvoiceDetail
        Inherits Global.Microsoft.LightSwitch.Framework.Base.EntityObject(Of __InvoiceDetail, __InvoiceDetail.DetailsClass)
    
        #Region "Constructors"
    
        ''' <summary>
        ''' Initializes a new instance of the InvoiceDetail entity.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New()
            Me.New(Nothing)
        End Sub
    
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New(entitySet As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __InvoiceDetail))
            MyBase.New(entitySet)
            
            __InvoiceDetail.DetailsClass.Initialize(Me)
        End Sub
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub InvoiceDetail_Created()
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub InvoiceDetail_AllowSaveWithErrors(ByRef result As Boolean)
        End Sub
    
        #End Region
    
        #Region "Private Properties"
        
        ''' <summary>
        ''' Gets the Application object for this application.  The Application object provides access to active screens, methods to open screens and access to the current user.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property Application As Global.Microsoft.LightSwitch.IApplication(Of Global.LightSwitchApplication.DataWorkspace)
            Get
                Return Global.LightSwitchApplication.Application.Current
            End Get
        End Property
        
        ''' <summary>
        ''' Gets the containing data workspace.  The data workspace provides access to all data sources in the application.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property DataWorkspace As Global.LightSwitchApplication.DataWorkspace
            Get
                Return DirectCast(Me.Details.EntitySet.Details.DataService.Details.DataWorkspace, Global.LightSwitchApplication.DataWorkspace)
            End Get
        End Property
        
        #End Region
    
        #Region "Public Properties"
    
        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Id As Integer
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Id)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Id, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property RowVersion As Byte()
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.RowVersion)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.RowVersion, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Quantity As Integer
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Quantity)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Quantity, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Quantity_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Quantity_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Quantity_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property PackQty As Decimal
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.PackQty)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.PackQty, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub PackQty_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub PackQty_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub PackQty_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Price As Decimal
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Price)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Price, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Price_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Price_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Price_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property SubTotal As Decimal
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.SubTotal)
            End Get
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub SubTotal_Compute(ByRef result As Decimal)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub SubTotal_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Discount As Decimal
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Discount)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Discount, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Discount_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Discount_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Discount_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public ReadOnly Property Total As Decimal
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Total)
            End Get
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Total_Compute(ByRef result As Decimal)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Total_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property InvoiceHeader As Global.LightSwitchApplication.InvoiceHeader
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.InvoiceHeader)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.InvoiceHeader, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub InvoiceHeader_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub InvoiceHeader_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub InvoiceHeader_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Product As Global.LightSwitchApplication.Product
            Get
                Return __InvoiceDetail.DetailsClass.GetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Product)
            End Get
            Set
                __InvoiceDetail.DetailsClass.SetValue(Me, __InvoiceDetail.DetailsClass.PropertySetProperties.Product, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Product_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Product_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Product_Changed()
        End Sub

        #End Region
    
        #Region "Details Class"
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
        <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public NotInheritable Class DetailsClass
            Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of _
                __InvoiceDetail, _
                __InvoiceDetail.DetailsClass, _
                __InvoiceDetail.DetailsClass.IImplementation, _
                __InvoiceDetail.DetailsClass.PropertySet, _
                Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __InvoiceDetail, __InvoiceDetail.DetailsClass), _
                Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __InvoiceDetail, __InvoiceDetail.DetailsClass))
    
            Shared Sub New()
                Dim initializeEntry = __InvoiceDetail.DetailsClass.PropertySetProperties.Id
            End Sub
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private Shared ReadOnly __InvoiceDetailEntry As Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __InvoiceDetail, __InvoiceDetail.DetailsClass).Entry = _
                New Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __InvoiceDetail, __InvoiceDetail.DetailsClass).Entry( _
                    AddressOf __InvoiceDetail.DetailsClass.__InvoiceDetail_CreateNew, _
                    AddressOf __InvoiceDetail.DetailsClass.__InvoiceDetail_Created, _
                    AddressOf __InvoiceDetail.DetailsClass.__InvoiceDetail_AllowSaveWithErrors)
            Private Shared Function __InvoiceDetail_CreateNew(es As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __InvoiceDetail)) As __InvoiceDetail
                Return New __InvoiceDetail(es)
            End Function
            Private Shared Sub __InvoiceDetail_Created(e As __InvoiceDetail)
                e.InvoiceDetail_Created()
            End Sub
            Private Shared Function __InvoiceDetail_AllowSaveWithErrors(e As __InvoiceDetail) As Boolean
                Dim result As Boolean = False
                e.InvoiceDetail_AllowSaveWithErrors(result)
                Return result
            End Function
    
            Public Sub New()
                MyBase.New()
            End Sub
    
            Public ReadOnly Shadows Property Commands As Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __InvoiceDetail, __InvoiceDetail.DetailsClass)
                Get
                    Return MyBase.Commands
                End Get
            End Property
    
            Public ReadOnly Shadows Property Methods As Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __InvoiceDetail, __InvoiceDetail.DetailsClass)
                Get
                    Return MyBase.Methods
                End Get
            End Property
    
            Public ReadOnly Shadows Property Properties As __InvoiceDetail.DetailsClass.PropertySet
                Get
                    Return MyBase.Properties
                End Get
            End Property
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Public NotInheritable Class PropertySet
                Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityPropertySet(Of __InvoiceDetail, __InvoiceDetail.DetailsClass)
    
                Public Sub New()
                    MyBase.New()
                End Sub
    
                Public ReadOnly Property Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.Id),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer))
                    End Get
                End Property
                
                Public ReadOnly Property RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Byte())
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.RowVersion),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Byte()))
                    End Get
                End Property
                
                Public ReadOnly Property Quantity As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.Quantity),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer))
                    End Get
                End Property
                
                Public ReadOnly Property PackQty As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.PackQty),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property Price As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.Price),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property SubTotal As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.SubTotal),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property Discount As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.Discount),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property Total As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.Total),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property InvoiceHeader As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.InvoiceHeader)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.InvoiceHeader),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.InvoiceHeader))
                    End Get
                End Property
                
                Public ReadOnly Property Product As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.Product)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__InvoiceDetail.DetailsClass.PropertySetProperties.Product),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.Product))
                    End Get
                End Property
                
            End Class
    
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            Public Interface IImplementation
                Inherits Global.Microsoft.LightSwitch.Internal.IEntityImplementation
    
                Shadows Property Id As Integer
                Shadows Property RowVersion As Byte()
                Shadows Property Quantity As Integer
                Shadows Property PackQty As Decimal
                Shadows Property Price As Decimal
                Shadows Property Discount As Decimal
                Shadows Property InvoiceHeader As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                Shadows Property Product As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
    
            End Interface
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Friend Class PropertySetProperties
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Entry( _
                        "Id", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Id_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Id_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Id_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Id_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Id_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Id_OnValueChanged)
                Private Shared Sub _Id_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._Id, sf)
                End Sub
                Private Shared Function _Id_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.Id_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Id_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Id_Validate(r)
                End Sub
                Private Shared Function _Id_GetImplementationValue(d As __InvoiceDetail.DetailsClass) As Integer
                    Return d.ImplementationEntity.Id
                End Function
                Private Shared Sub _Id_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Integer)
                    d.ImplementationEntity.Id = v
                End Sub
                Private Shared Sub _Id_OnValueChanged(e As __InvoiceDetail)
                    e.Id_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Byte()).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Byte()).Entry( _
                        "RowVersion", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._RowVersion_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._RowVersion_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._RowVersion_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._RowVersion_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._RowVersion_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._RowVersion_OnValueChanged)
                Private Shared Sub _RowVersion_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Byte()).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._RowVersion, sf)
                End Sub
                Private Shared Function _RowVersion_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.RowVersion_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _RowVersion_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.RowVersion_Validate(r)
                End Sub
                Private Shared Function _RowVersion_GetImplementationValue(d As __InvoiceDetail.DetailsClass) As Byte()
                    Return d.ImplementationEntity.RowVersion
                End Function
                Private Shared Sub _RowVersion_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Byte())
                    d.ImplementationEntity.RowVersion = v
                End Sub
                Private Shared Sub _RowVersion_OnValueChanged(e As __InvoiceDetail)
                    e.RowVersion_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Quantity As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Entry( _
                        "Quantity", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Quantity_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Quantity_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Quantity_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Quantity_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Quantity_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Quantity_OnValueChanged)
                Private Shared Sub _Quantity_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._Quantity, sf)
                End Sub
                Private Shared Function _Quantity_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.Quantity_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Quantity_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Quantity_Validate(r)
                End Sub
                Private Shared Function _Quantity_GetImplementationValue(d As __InvoiceDetail.DetailsClass) As Integer
                    Return d.ImplementationEntity.Quantity
                End Function
                Private Shared Sub _Quantity_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Integer)
                    d.ImplementationEntity.Quantity = v
                End Sub
                Private Shared Sub _Quantity_OnValueChanged(e As __InvoiceDetail)
                    e.Quantity_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly PackQty As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry( _
                        "PackQty", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._PackQty_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._PackQty_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._PackQty_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._PackQty_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._PackQty_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._PackQty_OnValueChanged)
                Private Shared Sub _PackQty_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._PackQty, sf)
                End Sub
                Private Shared Function _PackQty_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.PackQty_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _PackQty_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.PackQty_Validate(r)
                End Sub
                Private Shared Function _PackQty_GetImplementationValue(d As __InvoiceDetail.DetailsClass) As Decimal
                    Return d.ImplementationEntity.PackQty
                End Function
                Private Shared Sub _PackQty_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Decimal)
                    d.ImplementationEntity.PackQty = v
                End Sub
                Private Shared Sub _PackQty_OnValueChanged(e As __InvoiceDetail)
                    e.PackQty_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Price As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry( _
                        "Price", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Price_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Price_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Price_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Price_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Price_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Price_OnValueChanged)
                Private Shared Sub _Price_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._Price, sf)
                End Sub
                Private Shared Function _Price_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.Price_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Price_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Price_Validate(r)
                End Sub
                Private Shared Function _Price_GetImplementationValue(d As __InvoiceDetail.DetailsClass) As Decimal
                    Return d.ImplementationEntity.Price
                End Function
                Private Shared Sub _Price_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Decimal)
                    d.ImplementationEntity.Price = v
                End Sub
                Private Shared Sub _Price_OnValueChanged(e As __InvoiceDetail)
                    e.Price_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly SubTotal As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry( _
                        "SubTotal", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._SubTotal_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._SubTotal_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._SubTotal_ComputeValue)
                Private Shared Sub _SubTotal_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._SubTotal, sf)
                End Sub
                Private Shared Sub _SubTotal_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.SubTotal_Validate(r)
                End Sub
                Private Shared Function _SubTotal_ComputeValue(e As __InvoiceDetail) As Decimal
                    Dim value As Decimal = Nothing
                    e.SubTotal_Compute(value)
                    Return value
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Discount As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry( _
                        "Discount", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Discount_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Discount_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Discount_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Discount_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Discount_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Discount_OnValueChanged)
                Private Shared Sub _Discount_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._Discount, sf)
                End Sub
                Private Shared Function _Discount_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.Discount_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Discount_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Discount_Validate(r)
                End Sub
                Private Shared Function _Discount_GetImplementationValue(d As __InvoiceDetail.DetailsClass) As Decimal
                    Return d.ImplementationEntity.Discount
                End Function
                Private Shared Sub _Discount_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Decimal)
                    d.ImplementationEntity.Discount = v
                End Sub
                Private Shared Sub _Discount_OnValueChanged(e As __InvoiceDetail)
                    e.Discount_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Total As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Entry( _
                        "Total", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Total_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Total_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Total_ComputeValue)
                Private Shared Sub _Total_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._Total, sf)
                End Sub
                Private Shared Sub _Total_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Total_Validate(r)
                End Sub
                Private Shared Function _Total_ComputeValue(e As __InvoiceDetail) As Decimal
                    Dim value As Decimal = Nothing
                    e.Total_Compute(value)
                    Return value
                End Function
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly InvoiceHeader As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.InvoiceHeader).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.InvoiceHeader).Entry( _
                        "InvoiceHeader", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_GetCoreImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_Refresh, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._InvoiceHeader_OnValueChanged)
                Private Shared Sub _InvoiceHeader_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.InvoiceHeader).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._InvoiceHeader, sf)
                End Sub
                Private Shared Function _InvoiceHeader_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.InvoiceHeader_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _InvoiceHeader_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.InvoiceHeader_Validate(r)
                End Sub
                Private Shared Function _InvoiceHeader_GetCoreImplementationValue(d as __InvoiceDetail.DetailsClass) As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                    Return d.ImplementationEntity.InvoiceHeader
                End Function
                Private Shared Function _InvoiceHeader_GetImplementationValue(d as __InvoiceDetail.DetailsClass) As Global.LightSwitchApplication.InvoiceHeader
                    Return d.GetImplementationValue(Of Global.LightSwitchApplication.InvoiceHeader, Global.LightSwitchApplication.InvoiceHeader.DetailsClass)(__InvoiceDetail.DetailsClass.PropertySetProperties.InvoiceHeader, d._InvoiceHeader)
                End Function
                Private Shared Sub _InvoiceHeader_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Global.LightSwitchApplication.InvoiceHeader)
                    d.SetImplementationValue(__InvoiceDetail.DetailsClass.PropertySetProperties.InvoiceHeader, d._InvoiceHeader, Sub(i, ev) i.InvoiceHeader = ev, v)
                End Sub
                Private Shared Sub _InvoiceHeader_Refresh(d As __InvoiceDetail.DetailsClass)
                    d.RefreshNavigationProperty(__InvoiceDetail.DetailsClass.PropertySetProperties.InvoiceHeader, d._InvoiceHeader)
                End Sub
                Private Shared Sub _InvoiceHeader_OnValueChanged(e As __InvoiceDetail)
                    e.InvoiceHeader_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Product As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.Product).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.Product).Entry( _
                        "Product", _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_Stub, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_ComputeIsReadOnly, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_Validate, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_GetCoreImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_GetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_SetImplementationValue, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_Refresh, _
                        AddressOf __InvoiceDetail.DetailsClass.PropertySetProperties._Product_OnValueChanged)
                Private Shared Sub _Product_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __InvoiceDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.Product).Data), d As __InvoiceDetail.DetailsClass, sf As Object)
                    c(d, d._Product, sf)
                End Sub
                Private Shared Function _Product_ComputeIsReadOnly(e As __InvoiceDetail) As Boolean
                    Dim result As Boolean = False
                    e.Product_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Product_Validate(e As __InvoiceDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Product_Validate(r)
                End Sub
                Private Shared Function _Product_GetCoreImplementationValue(d as __InvoiceDetail.DetailsClass) As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                    Return d.ImplementationEntity.Product
                End Function
                Private Shared Function _Product_GetImplementationValue(d as __InvoiceDetail.DetailsClass) As Global.LightSwitchApplication.Product
                    Return d.GetImplementationValue(Of Global.LightSwitchApplication.Product, Global.LightSwitchApplication.Product.DetailsClass)(__InvoiceDetail.DetailsClass.PropertySetProperties.Product, d._Product)
                End Function
                Private Shared Sub _Product_SetImplementationValue(d As __InvoiceDetail.DetailsClass, v As Global.LightSwitchApplication.Product)
                    d.SetImplementationValue(__InvoiceDetail.DetailsClass.PropertySetProperties.Product, d._Product, Sub(i, ev) i.Product = ev, v)
                End Sub
                Private Shared Sub _Product_Refresh(d As __InvoiceDetail.DetailsClass)
                    d.RefreshNavigationProperty(__InvoiceDetail.DetailsClass.PropertySetProperties.Product, d._Product)
                End Sub
                Private Shared Sub _Product_OnValueChanged(e As __InvoiceDetail)
                    e.Product_Changed()
                End Sub
    
            End Class
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Byte()).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Quantity As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Integer).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _PackQty As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Price As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _SubTotal As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Discount As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Total As Global.Microsoft.LightSwitch.Details.Framework.EntityComputedProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _InvoiceHeader As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.InvoiceHeader).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Product As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __InvoiceDetail, __InvoiceDetail.DetailsClass, Global.LightSwitchApplication.Product).Data
            
        End Class
    
        #End Region
    
    End Class
    
    #End Region
End Namespace
